/*
    Objektovo orientovane programovanie (cvicenie 10)

    V kode su popisane ulohy. Postupne ich vypracujte.
    Ulohy obsahuju v zatvorkach nazvy metod potrebnych pre vypracovanie
    Niektore riadky su zakomentovane, aby sa program dal spustit. Pri vypracovani uloh treba tieto riadky odkomentovat
*/

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class Cvicenie10Cast1 {

    public static void main(String[] args) {
        
        //Definicia zoznamu slov, ktory budeme pouzivat v ulohach
        String text = "An object is a software bundle of related state and behavior. Software objects are often used to model the real-world objects that you find in everyday life. A class is a blueprint or prototype from which objects are created";
        String[] slovaTextu = text.split("\\.?\\s+"); //rozdeli text do pola slov. Oddelovacom je regularny vyraz. Oddelovac musi obsahovat aspon jeden biely znak. Pred bielymi znakmi moze byt bodka.
        System.out.println("tmpSlovaTextu: " + Arrays.toString(slovaTextu)); //kontrolny vypis
        List<String> slova = new ArrayList<>(Arrays.asList(slovaTextu));
        System.out.println("slova: " + slova); //kontrolny vypis

        System.out.println("---------------------------------------------------");
      
        //Vypiste posledny prvok v zozname (get, size)
        System.out.println("posledny prvok: " /*DOPLNTE*/);
        
        System.out.println("---------------------------------------------------");
        
        //Vypiste "true" alebo "false" podla toho ci zoznam obsahuje alebo neobsahuje
        //prvok v premennej hladanyPrvok (contains)
        String hladanyPrvok = "object";
        System.out.println("test ci zoznam obsahuje prvok \"" + hladanyPrvok + "\": " /*DOPLNTE*/);
        
        System.out.println("---------------------------------------------------");
        
        //Vypiste obsah zoznamu pomocou prudov a metody forEach (stream, forEach)
        System.out.println("vypis pomocou forEach: ");
        /*DOPLNTE*/
        System.out.println();
        
        System.out.println("---------------------------------------------------");
        
        //Zistite ci zoznam obsahuje aspon jedno slovo, ktore obsahuje 'podretazec' (stream, anyMatch, indexOf)
        String podretazec = "pro";
        boolean obsahujePodretazec = false; //UPRAVTE
        System.out.println("testovanie vyskytu \"" + podretazec + "\": " + obsahujePodretazec);
        
        System.out.println("---------------------------------------------------");
        
        //Vypiste pocet slov, ktorych dlzka je minimalne 4 a zacinaju sa retazcom "th"
        //Pouzite metody strem, filter, startWith, count a lambda vyraz
        long pocet = -1; //UPRAVTE
        System.out.println("pocet slov zacinajucich na th: " + pocet);
        
        System.out.println("---------------------------------------------------");

        //Zistite dlzku kazdeho retazca v zozname a scitajte tieto dlzky (stream, mapToInt, sum)
        int pocetZnakov = -1; //UPRAVTE
        System.out.println("sucet dlzok vsetkych retazcov: " + pocetZnakov);
        
        System.out.println("---------------------------------------------------");
        
        //Zistite priemernu dlzku retazca v zozname (stream, mapToInt, average, getAsDouble)
        double priemernyPocetZnakov = -1; //UPRAVTE
        System.out.println("priemerny pocet pismen v retazcoch: " + priemernyPocetZnakov);
        
        System.out.println("---------------------------------------------------");
        
        //Vytvorte mapu, ktora bude obsahovat retazce zo zoznamu 'slova'
        //Retazce budu v mape rozdelene podla poctu znakov
        //Kluce v mape budu pocety znakov. Na pocet znakov bude namapovana mnozina retazcov s prislusnou dlzkou
        System.out.println("slovaTextu: " + slova);
        Map<Integer, Set<String>> slovaPodlaDlzky = new HashMap<>();
        for(String slovo : slova) {
            //DOPLNTE
        }
        System.out.println("slovaPodlaDlzky: " + slovaPodlaDlzky);
        
        System.out.println("---------------------------------------------------");
        
        //Vymazte zo zoznamu vsetky slova dlhsie ako 5 znakov
        //v cykle for pouzite iterator (hasNext, next, remove)
        //for(/*DOPLNTE*/ it = slova.iterator(); /*DOPLNTE*/; ) {
        //  DOPLNTE
        //}
        System.out.println("po vymazani dlhych slov: " + slova);
        
        System.out.println("---------------------------------------------------");
        
        //Vymazte vsetky prvky zoznamu
        //DOPLNTE
        System.out.println("po vymazani celeho zoznamu: " + slova);
        
        System.out.println("---------------------------------------------------");
        
        //Mozeme do zoznamu 'zoznam' pridat dalsi retazec?
        List<String> zoznam = Arrays.asList(slovaTextu);
        //zoznam.add("dalsie"); //co sa stane po odkomentovani tohto riadku a spusteni programu?
    }
}
